<?php

namespace Shikiryu\WebGobbler;

abstract class Assembler
{
    /**
     * @var \Shikiryu\WebGobbler\Pool
     */
    protected $pool;

    /**
     * @var \Shikiryu\WebGobbler\Config
     */
    protected $config;

    /**
     * Assembler constructor.
     *
     * @param \Shikiryu\WebGobbler\Pool   $pool
     * @param \Shikiryu\WebGobbler\Config $config
     */
    public function __construct(Pool $pool, Config $config)
    {
        $this->pool = $pool;
        $this->config = $config;
    }

    /**
     * @param string $file
     *
     * @return void
     */
    abstract public function saveTo($file);

    abstract public function display();
}